package net.ddns.mahaljsp.cameraw.http

import com.shencoder.mvvmkit.http.BaseRetrofitClient
import com.squareup.moshi.Moshi
import com.squareup.moshi.kotlin.reflect.KotlinJsonAdapterFactory
import net.ddns.mahaljsp.cameraw.G
import okhttp3.OkHttpClient
import okhttp3.logging.HttpLoggingInterceptor
import retrofit2.Retrofit
import retrofit2.converter.moshi.MoshiConverterFactory
import java.security.KeyStore
import java.security.SecureRandom
import java.security.cert.X509Certificate
import javax.net.ssl.HostnameVerifier
import javax.net.ssl.SSLContext
import javax.net.ssl.TrustManager
import javax.net.ssl.TrustManagerFactory
import javax.net.ssl.X509TrustManager

class RetrofitClient : BaseRetrofitClient() {
    private companion object {
        val BASE_URL =
            "http://${G.SRS_SERVER_HTTP}"
    }

    val apiService by lazy {
        getApiService(
            ApiService::class.java,
            BASE_URL
        )
    }

    override fun generateOkHttpBuilder(builder: OkHttpClient.Builder): OkHttpClient.Builder {
        val xtm: X509TrustManager = object : X509TrustManager {

            override fun checkClientTrusted(chain: Array<out X509Certificate>?, authType: String?) {
            }

            override fun checkServerTrusted(chain: Array<out X509Certificate>?, authType: String?) {
            }

            override fun getAcceptedIssuers(): Array<X509Certificate> {
                return arrayOf()
            }

        }

        val sslContext = SSLContext.getInstance("SSL")
        sslContext.init(null, arrayOf<TrustManager>(xtm), SecureRandom())
        val hostnameVerifier = HostnameVerifier { hostname, session -> true }

        //val interceptor = HttpLoggingInterceptor { message -> XLog.i(message) }
        val interceptor = HttpLoggingInterceptor{}
        interceptor.level =HttpLoggingInterceptor.Level.NONE
            //if (BuildConfig.DEBUG) HttpLoggingInterceptor.Level.BASIC
            //else HttpLoggingInterceptor.Level.NONE
        val trustManagerFactory =
            TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm())

        trustManagerFactory.init(null as KeyStore?)
        val trustManagers = trustManagerFactory.trustManagers
        check(!(trustManagers.size != 1 || trustManagers[0] !is X509TrustManager)) { "Unexpected default trust managers:" + trustManagers.contentToString() }
        val trustManager = trustManagers[0] as X509TrustManager
        //val sslContext = SSLContext.getInstance("SSL")
        //sslContext.init(null, arrayOf<TrustManager>(trustManager), null)
        //val sslSocketFactory: SSLSocketFactory = sslContext.socketFactory
        //val client: OkHttpClient = Builder().sslSocketFactory(sslSocketFactory, trustManager)
        return builder.addInterceptor(interceptor)
            .sslSocketFactory(sslContext.socketFactory, trustManager)
            .hostnameVerifier(hostnameVerifier)
    }

    override fun generateRetrofitBuilder(builder: Retrofit.Builder): Retrofit.Builder {
        return builder.apply {
            val moshi = Moshi.Builder()
                .addLast(KotlinJsonAdapterFactory())
                .build()
            addConverterFactory(MoshiConverterFactory.create(moshi))
        }

    }
}